/*
 * conn.c
 */

#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>

#define MAXMESG 2048

dg_echo(sockfd, pcli_addr, maxclilen)
int sockfd;
struct sockaddr *pcli_addr;
int maxclilen;
{
    int i,n, clilen, nosent;
    char mesg[MAXMESG];
    char revmesg[MAXMESG];

    for (;;) {
        clilen = maxclilen;
        n = recvfrom(sockfd, mesg, MAXMESG, 0, pcli_addr, &clilen);
        if (n<0) {
            printf("errno = %d\n", errno);
            printf("dg_echo: recvfrom error\n");
            exit(3);
        }

	for(i=0;i<n;i++) 
	{
		printf("%02X ",mesg[i]);
		revmesg[i]=mesg[n-i-1];
	}
	printf("\n");
        if ((nosent = sendto(sockfd, revmesg, n, 0, pcli_addr, clilen)) != n) {
            printf("nosent = %d\n", nosent);
            printf("dg_echo: sendto error\n");
            exit(4);
        }
    }
}

#define MAXLINE 512

dg_cli(fp, sockfd, pserv_addr, servlen)
FILE *fp;
int sockfd;
struct sockaddr *pserv_addr;
int servlen;
{
    int n, nosent;
    char sendline[MAXLINE], recvline[MAXLINE + 1];

    while (fgets(sendline,MAXLINE,fp) != NULL) {
        n = strlen(sendline);
        if ((nosent = sendto(sockfd, sendline, n, 0, pserv_addr, servlen)) != n
)
        {
             printf("nosent = %d\n", nosent);
            printf("dg_cli: sendto error on socket\n");
            exit(5);
        }

        n = recvfrom(sockfd, recvline, MAXLINE,0,
            (struct sockaddr *)0, (int *)0);
        if (n<0) {
             printf("errno = %d\n", errno);
            printf("dg_cli: recvfrom error\n");
            exit(5);
        }
        recvline[n] = 0;
        fputs(recvline,stdout);
    }
    if(ferror(fp))
        printf("dg_cli: error reading file\n");
}



